namespace eval ttk::progressbar {
    variable Timers	;# Map: widget name -> after ID
}
proc ttk::progressbar::Autoincrement {pb steptime stepsize} {
    variable Timers
    if {![winfo exists $pb]} {
	unset -nocomplain Timers($pb)
	return
    }
    set Timers($pb) [after $steptime \
    	[list ttk::progressbar::Autoincrement $pb $steptime $stepsize] ]
    $pb step $stepsize
}
proc ttk::progressbar::start {pb {steptime 50} {stepsize 1}} {
    variable Timers
    if {![info exists Timers($pb)]} {
	Autoincrement $pb $steptime $stepsize
    }
}
proc ttk::progressbar::stop {pb} {
    variable Timers
    if {[info exists Timers($pb)]} {
	after cancel $Timers($pb)
	unset Timers($pb)
    }
    $pb configure -value 0
}